diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
index cd86fedc4..36f7f2742 100644
--- a/src/CMakeLists.txt
+++ b/src/CMakeLists.txt
@@ -209,8 +209,10 @@ INCLUDE(CPack)
 
 SET(CDOGS_SDL_EDITOR_SOURCES
 	cdogsed.c
-	charsed.c)
+	charsed.c
+	mouse.c)
 SET(CDOGS_SDL_EDITOR_HEADERS
-	charsed.h)
+	charsed.h
+	mouse.h)
 add_executable(cdogs-sdl-editor ${CDOGS_SDL_EDITOR_SOURCES} ${CDOGS_SDL_EDITOR_HEADERS} ${CDOGS_SDL_EXTRA})
 target_link_libraries(cdogs-sdl-editor cdogs json ${SDL_LIBRARY} ${SDLMIXER_LIBRARY} ${EXTRA_LIBRARIES})
diff --git a/src/cdogs/events.c b/src/cdogs/events.c
index 8403f6bd1..0653e8e61 100644
--- a/src/cdogs/events.c
+++ b/src/cdogs/events.c
@@ -50,39 +50,8 @@
 #include <stdlib.h>
 #include "events.h"
 #include "keyboard.h"
-#include "SDL.h"
 
 
-static struct MouseRect *localRects = NULL;
-static struct MouseRect *localRects2 = NULL;
-
-
-void InitMouse(void)
-{
-	SDL_ShowCursor(SDL_DISABLE);
-}
-
-void Mouse(int *x, int *y, int *button)
-{
-	SDL_Event event;
-
-	/* I'm not sure whether this works */
-	if (SDL_PollEvent(&event)) {
-		switch (event.type) {
-			case SDL_MOUSEMOTION:
-				*x = event.motion.x;
-				*y = event.motion.y;
-				*button = 0;
-				break;
-			case SDL_MOUSEBUTTONDOWN:
-				*x = event.button.x;
-				*y = event.button.y;
-				*button = 1;
-				break;
-		}
-	}
-}
-
 int GetKey(keyboard_t *keyboard)
 {
 	int key_pressed = 0;
@@ -114,47 +83,3 @@ void WaitForAnyKeyOrButton(keyboard_t *keyboard, joysticks_t *joysticks)
 		}
 	}
 }
-
-void SetMouseRects(struct MouseRect *rects)
-{
-	localRects = rects;
-	localRects2 = NULL;
-}
-
-void SetSecondaryMouseRects(struct MouseRect *rects)
-{
-	localRects2 = rects;
-}
-
-int GetMouseRectTag(int x, int y, int *tag)
-{
-	struct MouseRect *mRect;
-	int i;
-
-	for (i = 0, mRect = localRects; mRect && mRect->right > 0; i++, mRect++) {
-		if (y >= mRect->top && y <= mRect->bottom &&
-			x >= mRect->left && x <= mRect->right) {
-			*tag = mRect->tag;
-			return 1;
-		}
-	}
-	for (i = 0, mRect = localRects2; mRect && mRect->right > 0; i++, mRect++) {
-		if (y >= mRect->top && y <= mRect->bottom &&
-			x >= mRect->left && x <= mRect->right) {
-			*tag = mRect->tag;
-			return 1;
-		}
-	}
-	return 0;
-}
-
-
-int IsEventPending (Uint32 m) {
-	SDL_Event e;
-
-	if (SDL_PeepEvents(&e, 1, SDL_GETEVENT, m)) {
-		return 1;
-	} else {
-		return 0;
-	}
-}
diff --git a/src/cdogs/events.h b/src/cdogs/events.h
index 7e789cdef..237c610c5 100644
--- a/src/cdogs/events.h
+++ b/src/cdogs/events.h
@@ -52,22 +52,7 @@
 #include "joystick.h"
 #include "keyboard.h"
 
-struct MouseRect {
-	int left, top, right, bottom;
-	int tag;
-};
-
-
-void InitMouse(void);
-void Mouse(int *x, int *y, int *button);
 int GetKey(keyboard_t *keyboard);
 void WaitForAnyKeyOrButton(keyboard_t *keyboard, joysticks_t *joysticks);
-void SetMouseRects(struct MouseRect *rects);
-void SetSecondaryMouseRects(struct MouseRect *rects);
-int GetMouseRectTag(int x, int y, int *tag);
-
-#define EVENT_QUIT	SDL_QUITMASK
-#define EVENT_ACTIVE	SDL_ACTIVEEVENTMASK
-int IsEventPending (unsigned int m);
 
 #endif
diff --git a/src/cdogs/vector.c b/src/cdogs/vector.c
index 8ed70676d..4964bdf80 100644
--- a/src/cdogs/vector.c
+++ b/src/cdogs/vector.c
@@ -54,6 +54,18 @@ Vec2i Vec2iScale(Vec2i v, int scalar)
 	return v;
 }
 
+Vec2i Vec2iScaleDiv(Vec2i v, int scaleDiv)
+{
+	v.x /= scaleDiv;
+	v.y /= scaleDiv;
+	return v;
+}
+
+int Vec2iEqual(Vec2i a, Vec2i b)
+{
+	return a.x == b.x && a.y == b.y;
+}
+
 void CalcChebyshevDistanceAndBearing(
 	Vec2i origin, Vec2i target, int *distance, int *bearing)
 {
diff --git a/src/cdogs/vector.h b/src/cdogs/vector.h
index 6190e58f0..987506965 100644
--- a/src/cdogs/vector.h
+++ b/src/cdogs/vector.h
@@ -40,6 +40,8 @@ Vec2i Vec2iNew(int x, int y);
 Vec2i Vec2iZero(void);
 Vec2i Vec2iAdd(Vec2i a, Vec2i b);
 Vec2i Vec2iScale(Vec2i v, int scalar);
+Vec2i Vec2iScaleDiv(Vec2i v, int scaleDiv);
+int Vec2iEqual(Vec2i a, Vec2i b);
 
 int DistanceSquared(Vec2i a, Vec2i b);
 void CalcChebyshevDistanceAndBearing(
diff --git a/src/cdogsed.c b/src/cdogsed.c
index 007cf4387..12213a4ce 100644
--- a/src/cdogsed.c
+++ b/src/cdogsed.c
@@ -18,6 +18,33 @@
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+    This file incorporates work covered by the following copyright and
+    permission notice:
+
+    Copyright (c) 2013, Cong Xu
+    All rights reserved.
+
+    Redistribution and use in source and binary forms, with or without
+    modification, are permitted provided that the following conditions are met:
+
+    Redistributions of source code must retain the above copyright notice, this
+    list of conditions and the following disclaimer.
+    Redistributions in binary form must reproduce the above copyright notice,
+    this list of conditions and the following disclaimer in the documentation
+    and/or other materials provided with the distribution.
+
+    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+    ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+    POSSIBILITY OF SUCH DAMAGE.
 */
 
 #include <stdlib.h>
@@ -42,6 +69,7 @@
 #include <cdogs/utils.h>
 
 #include "charsed.h"
+#include "mouse.h"
 
 
 #define YC_CAMPAIGNTITLE    0
@@ -100,7 +128,8 @@
 
 // Mouse click areas:
 
-static struct MouseRect localClicks[] = {
+static MouseRect localClicks[] =
+{
 	{25, 5, 265, 5 + TH - 1, YC_CAMPAIGNTITLE + SELECT_ONLY},
 	{270, 5, 319, 5 + TH - 1, YC_MISSIONINDEX + SELECT_ONLY},
 	{25, 8 + TH, 200, 8 + 2 * TH - 1, YC_MISSIONTITLE + SELECT_ONLY},
@@ -163,7 +192,8 @@ static struct MouseRect localClicks[] = {
 	{0, 0, 0, 0, 0}
 };
 
-static struct MouseRect localCampaignClicks[] = {
+static MouseRect localCampaignClicks[] =
+{
 	{0, 150, 319, 150 + TH - 1,
 	 YC_CAMPAIGNTITLE + (XC_AUTHOR << 8) + SELECT_ONLY},
 	{0, 150 + TH, 319, 190,
@@ -172,14 +202,16 @@ static struct MouseRect localCampaignClicks[] = {
 	{0, 0, 0, 0, 0}
 };
 
-static struct MouseRect localMissionClicks[] = {
+static MouseRect localMissionClicks[] =
+{
 	{0, 150, 319, 160,
 	 YC_MISSIONTITLE + (XC_MUSICFILE << 8) + SELECT_ONLY},
 
 	{0, 0, 0, 0, 0}
 };
 
-static struct MouseRect localWeaponClicks[] = {
+static MouseRect localWeaponClicks[] =
+{
 	{10, 150, 90, 150 + TH - 1, LEAVE_YC + (0 << 8)},
 	{10, 150 + TH, 90, 150 + 2 * TH - 1, LEAVE_YC + (1 << 8)},
 	{10, 150 + 2 * TH, 90, 150 + 3 * TH - 1, LEAVE_YC + (2 << 8)},
@@ -197,7 +229,8 @@ static struct MouseRect localWeaponClicks[] = {
 	{0, 0, 0, 0, 0}
 };
 
-static struct MouseRect localMapItemClicks[] = {
+static MouseRect localMapItemClicks[] =
+{
 	{0, 150, 19, 190, LEAVE_YC + (0 << 8)},
 	{20, 150, 39, 190, LEAVE_YC + (1 << 8)},
 	{40, 150, 59, 190, LEAVE_YC + (2 << 8)},
@@ -218,7 +251,8 @@ static struct MouseRect localMapItemClicks[] = {
 	{0, 0, 0, 0, 0}
 };
 
-static struct MouseRect localObjectiveClicks[] = {
+static MouseRect localObjectiveClicks[] =
+{
 	{20, 150, 55, 190, LEAVE_YC + (XC_TYPE << 8)},
 	{60, 150, 85, 190, LEAVE_YC + (XC_INDEX << 8)},
 	{90, 150, 105, 190, LEAVE_YC + (XC_REQUIRED << 8)},
@@ -228,7 +262,8 @@ static struct MouseRect localObjectiveClicks[] = {
 	{0, 0, 0, 0, 0}
 };
 
-static struct MouseRect localCharacterClicks[] = {
+static MouseRect localCharacterClicks[] =
+{
 	{10, 150, 29, 190, LEAVE_YC + (0 << 8) + SELECT_ONLY_FIRST},
 	{30, 150, 49, 190, LEAVE_YC + (1 << 8) + SELECT_ONLY_FIRST},
 	{50, 150, 69, 190, LEAVE_YC + (2 << 8) + SELECT_ONLY_FIRST},
@@ -354,7 +389,7 @@ void DrawObjectiveInfo(int idx, int y, int xc)
 		(currentMission->objectives[idx].flags & OBJECTIVE_NOACCESS) != 0 ? "no-access" : "");
 	DisplayCDogsText(150, y, s, xc == XC_FLAGS, 0);
 
-	SetSecondaryMouseRects(localObjectiveClicks);
+	MouseSetSecondaryRects(&gMouse, localObjectiveClicks);
 }
 
 int MissionDescription(int y, const char *description, int hilite)
@@ -469,7 +504,7 @@ void ListWeapons(int y, int xc)
 	ShowWeaponStatus(190, y + TH, 9, xc);
 	ShowWeaponStatus(190, y + 2 * TH, 10, xc);
 
-	SetSecondaryMouseRects(localWeaponClicks);
+	MouseSetSecondaryRects(&gMouse, localWeaponClicks);
 }
 
 void DisplayMapItem(int x, int y, TMapObject * mo, int density, int hilite)
@@ -487,7 +522,7 @@ void DisplayMapItem(int x, int y, TMapObject * mo, int density, int hilite)
 	CDogsTextGoto(x - 8, y + 5);
 	CDogsTextString(s);
 
-	SetSecondaryMouseRects(localMapItemClicks);
+	MouseSetSecondaryRects(&gMouse, localMapItemClicks);
 }
 
 void Display(int idx, int xc, int yc, int key)
@@ -496,7 +531,7 @@ void Display(int idx, int xc, int yc, int key)
 	int y = 5;
 	int i;
 
-	SetSecondaryMouseRects(NULL);
+	MouseSetSecondaryRects(&gMouse, NULL);
 	for (i = 0; i < GraphicsGetScreenSize(&gGraphicsDevice.cachedConfig); i++)
 	{
 		gGraphicsDevice.buf[i] = LookupPalette(58);
@@ -655,14 +690,14 @@ void Display(int idx, int xc, int yc, int key)
 		MissionDescription(150 + TH, campaign.description,
 				   yc == YC_CAMPAIGNTITLE
 				   && xc == XC_CAMPAIGNDESC);
-		SetSecondaryMouseRects(localCampaignClicks);
+		MouseSetSecondaryRects(&gMouse, localCampaignClicks);
 		break;
 
 	case YC_MISSIONTITLE:
 		DisplayCDogsText(20, 150, currentMission->song,
 			    yc == YC_MISSIONTITLE
 			    && xc == XC_MUSICFILE, 1);
-		SetSecondaryMouseRects(localMissionClicks);
+		MouseSetSecondaryRects(&gMouse, localMissionClicks);
 		break;
 
 	case YC_MISSIONDESC:
@@ -678,7 +713,7 @@ void Display(int idx, int xc, int yc, int key)
 		for (i = 0; i < currentMission->baddieCount; i++)
 			DisplayCharacter(20 + 20 * i, y,
 					 CHARACTER_OTHERS + i, xc == i);
-		SetSecondaryMouseRects(localCharacterClicks);
+		MouseSetSecondaryRects(&gMouse, localCharacterClicks);
 		break;
 
 	case YC_SPECIALS:
@@ -691,7 +726,7 @@ void Display(int idx, int xc, int yc, int key)
 					 CHARACTER_OTHERS +
 					 currentMission->baddieCount + i,
 					 xc == i);
-		SetSecondaryMouseRects(localCharacterClicks);
+		MouseSetSecondaryRects(&gMouse, localCharacterClicks);
 		break;
 
 	case YC_ITEMS:
@@ -724,6 +759,8 @@ void Display(int idx, int xc, int yc, int key)
 		break;
 	}
 
+	MouseDraw(&gMouse);
+
 	BlitFlip(&gGraphicsDevice, &gConfig.Graphics);
 }
 
@@ -1283,55 +1320,61 @@ static int ConfirmQuit(void)
 static void EditCampaign(void)
 {
 	int done = 0;
-	int c = 0;
 	int mission = 0;
 	int xc = 0, yc = 0;
 	int xcOld, ycOld;
 	struct Mission scrap;
 	struct EditorInfo edInfo;
-	int x, y, buttons, tag;
+	int tag;
 
 	GetEditorInfo(&edInfo);
 
 	memset(&scrap, 0, sizeof(scrap));
-	SetMouseRects(localClicks);
+	MouseSetRects(&gMouse, localClicks, NULL);
 
 	gCampaign.Setting = campaign;
 	gCampaign.seed = 0;
 	Setup(mission, 1);
 
 	SDL_EnableKeyRepeat(0, 0);
-	while (!done) {
-		Display(mission, xc, yc, c);
-
-		do {
-			GetEvent(&c, &x, &y, &buttons);
-			if (buttons) {
-				if (GetMouseRectTag(x, y, &tag)) {
-					xcOld = xc;
-					ycOld = yc;
-					if ((tag & LEAVE_YC) == 0) {
-						yc = (tag & 0xFF);
-						AdjustYC(&yc);
-					}
-					if ((tag & LEAVE_XC) == 0) {
-						xc = ((tag >> 8) & 0xFF);
-						AdjustXC(yc, &xc);
-					}
-					if ((tag & SELECT_ONLY) != 0)
-						c = DUMMY;
-					else if ((tag & SELECT_ONLY_FIRST)
-						 == 0 || (xc == xcOld
-							  && yc == ycOld))
-						c = (buttons ==
-						     1 ? PAGEUP :
-						     PAGEDOWN);
-					else
-						c = DUMMY;
+	while (!done)
+	{
+		int c;
+		KeyPoll(&gKeyboard);
+		c = KeyGetPressed(&gKeyboard);
+		MousePoll(&gMouse);
+		if (gMouse.currentButtons)
+		{
+			if (MouseTryGetRectTag(&gMouse, &tag))
+			{
+				xcOld = xc;
+				ycOld = yc;
+				if ((tag & LEAVE_YC) == 0)
+				{
+					yc = (tag & 0xFF);
+					AdjustYC(&yc);
+				}
+				if ((tag & LEAVE_XC) == 0)
+				{
+					xc = ((tag >> 8) & 0xFF);
+					AdjustXC(yc, &xc);
+				}
+				if ((tag & SELECT_ONLY) != 0)
+				{
+					c = DUMMY;
+				}
+				else if (!(tag & SELECT_ONLY_FIRST) ||
+					(xc == xcOld && yc == ycOld))
+				{
+					c = gMouse.currentButtons == SDL_BUTTON_LEFT ?
+						PAGEUP : PAGEDOWN;
+				}
+				else
+				{
+					c = DUMMY;
 				}
 			}
 		}
-		while (!c);
 
 		switch (c) {
 		case HOME:
@@ -1489,7 +1532,7 @@ static void EditCampaign(void)
 		case ALT_E:
 			EditCharacters(&campaign);
 			Setup(mission, 0);
-			SetMouseRects(localClicks);
+			MouseSetRects(&gMouse, localClicks, NULL);
 			break;
 
 		default:
@@ -1499,6 +1542,8 @@ static void EditCampaign(void)
 			}
 			break;
 		}
+		Display(mission, xc, yc, c);
+		SDL_Delay(10);
 	}
 }
 
@@ -1567,6 +1612,9 @@ int main(int argc, char *argv[])
 	ConfigLoadDefault(&gConfig);
 	ConfigLoad(&gConfig, GetConfigFilePath(CONFIG_FILE));
 	GraphicsInit(&gGraphicsDevice);
+	// Override config for editor; only 320x240 supported
+	gConfig.Graphics.ResolutionWidth = 320;
+	gConfig.Graphics.ResolutionHeight = 240;
 	GraphicsInitialize(&gGraphicsDevice, &gConfig.Graphics, 0);
 	if (!gGraphicsDevice.IsInitialized)
 	{
@@ -1577,7 +1625,7 @@ int main(int argc, char *argv[])
 	CDogsSetPalette(gPalette);
 
 	KeyInit(&gKeyboard);
-	InitMouse();
+	MouseInit(&gMouse, gPics[145]);
 	EditCampaign();
 
 	GraphicsTerminate(&gGraphicsDevice);
diff --git a/src/charsed.c b/src/charsed.c
index d6b48407a..82beaa1b5 100644
--- a/src/charsed.c
+++ b/src/charsed.c
@@ -18,6 +18,33 @@
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+    This file incorporates work covered by the following copyright and
+    permission notice:
+
+    Copyright (c) 2013, Cong Xu
+    All rights reserved.
+
+    Redistribution and use in source and binary forms, with or without
+    modification, are permitted provided that the following conditions are met:
+
+    Redistributions of source code must retain the above copyright notice, this
+    list of conditions and the following disclaimer.
+    Redistributions in binary form must reproduce the above copyright notice,
+    this list of conditions and the following disclaimer in the documentation
+    and/or other materials provided with the distribution.
+
+    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+    ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+    POSSIBILITY OF SUCH DAMAGE.
 */
 #include "charsed.h"
 
@@ -30,7 +57,6 @@
 #include <cdogs/actors.h>
 #include <cdogs/config.h>
 #include <cdogs/defs.h>
-#include <cdogs/events.h>
 #include <cdogs/grafx.h>
 #include <cdogs/keyboard.h>
 #include <cdogs/mission.h>
@@ -38,6 +64,8 @@
 #include <cdogs/text.h>
 #include <cdogs/utils.h>
 
+#include "mouse.h"
+
 
 #define YC_APPEARANCE 0
 #define YC_ATTRIBUTES 1
@@ -84,7 +112,8 @@ int fileChanged = 0;
 extern void *myScreen;
 
 
-static struct MouseRect localClicks[] = {
+static MouseRect localClicks[] =
+{
 	{30, 10, 55, 10 + TH - 1, YC_APPEARANCE + (XC_FACE << 8)},
 	{60, 10, 85, 10 + TH - 1, YC_APPEARANCE + (XC_SKIN << 8)},
 	{90, 10, 115, 10 + TH - 1, YC_APPEARANCE + (XC_HAIR << 8)},
@@ -139,16 +168,18 @@ static struct MouseRect localClicks[] = {
 };
 
 
-static int XYToCharacterIndex(int x, int y, int *idx)
+static int PosToCharacterIndex(Vec2i pos, int *idx)
 {
-	if (y < 10 + 5 * TH + 5)
+	if (pos.y < 10 + 5 * TH + 5)
+	{
 		return 0;
+	}
 
-	y -= 10 + 5 * TH + 5;
+	pos.y -= 10 + 5 * TH + 5;
 
-	x /= 20;
-	y /= 30;
-	*idx = 16 * y + x;
+	pos.x /= 20;
+	pos.y /= 30;
+	*idx = 16 * pos.y + pos.x;
 	return 1;
 }
 
@@ -306,6 +337,8 @@ static void Display(CampaignSetting *setting, int idx, int xc, int yc)
 		}
 	}
 
+	MouseDraw(&gMouse);
+
 	BlitFlip(&gGraphicsDevice, &gConfig.Graphics);
 }
 
@@ -517,11 +550,6 @@ static void AdjustXC(int yc, int *xc)
 	}
 }
 
-void DrawCursor(int x, int y)
-{
-	DrawTPic(x, y, gPics[145]);
-}
-
 void RestoreBkg(int x, int y, unsigned int *bkg)
 {
 	int w = ((short *) (gPics[145]))[0];
@@ -551,75 +579,43 @@ void RestoreBkg(int x, int y, unsigned int *bkg)
 	}
 }
 
-void GetEvent(int *key, int *x, int *y, int *buttons)
-{
-	static int scaling = 1;
-
-	int xPrev = -1, yPrev = -1;
-	//void *old = GetDstScreen();
-
-	Mouse(x, y, buttons);
-
-	*buttons = *key = 0;
-	do
-	{
-		KeyPoll(&gKeyboard);
-		*key = KeyGetPressed(&gKeyboard);
-
-		Mouse(x, y, buttons);
-		*x /= scaling;
-		if (*x > 319)
-			scaling++;
-
-		if (!(*buttons) && !(*key) && (*x != xPrev || *y != yPrev))
-		{
-			DrawCursor(*x, *y);
-			xPrev = *x;
-			yPrev = *y;
-		}
-		SDL_Delay(10);
-	}
-	while (!(*buttons) && !(*key));
-}
-
 void EditCharacters(CampaignSetting *setting)
 {
 	int done = 0;
-	int c = 0;
 	int idx = 0;
 	int xc = 0, yc = 0;
 	TBadGuy scrap;
-	int x, y, buttons, tag;
 
 	memset(&scrap, 0, sizeof(scrap));
-	SetMouseRects(localClicks);
+	MouseSetRects(&gMouse, localClicks, NULL);
 
 	while (!done)
 	{
-		Display(setting, idx, xc, yc);
-
-		do {
-			GetEvent(&c, &x, &y, &buttons);
-			if (buttons)
+		int tag;
+		int c;
+		KeyPoll(&gKeyboard);
+		c = KeyGetPressed(&gKeyboard);
+		MousePoll(&gMouse);
+		if (gMouse.currentButtons)
+		{
+			if (PosToCharacterIndex(gMouse.currentPos, &tag))
 			{
-				if (XYToCharacterIndex(x, y, &tag))
+				if (tag >= 0 && tag < setting->characterCount)
 				{
-					if (tag >= 0 && tag < setting->characterCount)
-					{
-						idx = tag;
-					}
-					c = DUMMY;
-				} else if (GetMouseRectTag(x, y, &tag)) {
-					xc = (tag >> 8);
-					yc = (tag & 0xFF);
-					AdjustYC(&yc);
-					AdjustXC(yc, &xc);
-					c = (buttons ==
-					     1 ? PAGEUP : PAGEDOWN);
+					idx = tag;
 				}
+				c = DUMMY;
+			}
+			else if (MouseTryGetRectTag(&gMouse, &tag))
+			{
+				xc = (tag >> 8);
+				yc = (tag & 0xFF);
+				AdjustYC(&yc);
+				AdjustXC(yc, &xc);
+				c = gMouse.currentButtons == SDL_BUTTON_LEFT ?
+					PAGEUP : PAGEDOWN;
 			}
 		}
-		while (!c);
 
 		switch (c) {
 		case HOME:
@@ -700,5 +696,7 @@ void EditCharacters(CampaignSetting *setting)
 			done = 1;
 			break;
 		}
+		Display(setting, idx, xc, yc);
+		SDL_Delay(10);
 	}
 }
diff --git a/src/charsed.h b/src/charsed.h
index 18b6d3592..632620028 100644
--- a/src/charsed.h
+++ b/src/charsed.h
@@ -67,7 +67,6 @@ extern int fileChanged;
 
 
 void DisplayFlag(int x, int y, const char *s, int on, int hilite);
-void GetEvent(int *key, int *x, int *y, int *buttons);
 void EditCharacters(CampaignSetting *setting);
 
 #endif
diff --git a/src/mouse.c b/src/mouse.c
new file mode 100644
index 000000000..4ef205a83
--- /dev/null
+++ b/src/mouse.c
@@ -0,0 +1,121 @@
+/*
+    C-Dogs SDL
+    A port of the legendary (and fun) action/arcade cdogs.
+    Copyright (C) 1995 Ronny Wester
+    Copyright (C) 2003 Jeremy Chin
+    Copyright (C) 2003-2007 Lucas Martin-King
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+    This file incorporates work covered by the following copyright and
+    permission notice:
+
+    Copyright (c) 2013, Cong Xu
+    All rights reserved.
+
+    Redistribution and use in source and binary forms, with or without
+    modification, are permitted provided that the following conditions are met:
+
+    Redistributions of source code must retain the above copyright notice, this
+    list of conditions and the following disclaimer.
+    Redistributions in binary form must reproduce the above copyright notice,
+    this list of conditions and the following disclaimer in the documentation
+    and/or other materials provided with the distribution.
+
+    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+    ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+    POSSIBILITY OF SUCH DAMAGE.
+*/
+#include "mouse.h"
+
+#include <SDL_events.h>
+#include <SDL_mouse.h>
+
+#include <cdogs/config.h>
+
+Mouse gMouse;
+
+void MouseInit(Mouse *mouse, Pic *cursor)
+{
+	memset(mouse, 0, sizeof *mouse);
+	mouse->cursor = cursor;
+	SDL_ShowCursor(SDL_DISABLE);
+}
+
+void MousePoll(Mouse *mouse)
+{
+	mouse->previousButtons = mouse->currentButtons;
+	mouse->previousPos = mouse->currentPos;
+	SDL_GetMouseState(&mouse->currentPos.x, &mouse->currentPos.y);
+	mouse->currentPos =
+		Vec2iScaleDiv(mouse->currentPos, gConfig.Graphics.ScaleFactor);
+}
+
+int MouseHasMoved(Mouse *mouse)
+{
+	return !Vec2iEqual(mouse->previousPos, mouse->currentPos);
+}
+
+void MouseSetRects(Mouse *mouse, MouseRect *rects, MouseRect *rects2)
+{
+	mouse->rects = rects;
+	mouse->rects2 = rects2;
+}
+
+void MouseSetSecondaryRects(Mouse *mouse, MouseRect *rects)
+{
+	mouse->rects2 = rects;
+}
+
+static int TryGetRectTag(MouseRect *rects, Vec2i pos, int *tag)
+{
+	while (rects && rects->right > 0)
+	{
+		if (pos.y >= rects->top && pos.y <= rects->bottom &&
+			pos.x >= rects->left && pos.x <= rects->right)
+		{
+			*tag = rects->tag;
+			return 1;
+		}
+		rects++;
+	}
+	return 0;
+}
+
+int MouseTryGetRectTag(Mouse *mouse, int *tag)
+{
+	if (TryGetRectTag(mouse->rects, mouse->currentPos, tag))
+	{
+		return 1;
+	}
+	if (TryGetRectTag(mouse->rects2, mouse->currentPos, tag))
+	{
+		return 1;
+	}
+	return 0;
+}
+
+void MouseDraw(Mouse *mouse)
+{
+	DrawTPic(mouse->currentPos.x, mouse->currentPos.y, mouse->cursor);
+}
diff --git a/src/mouse.h b/src/mouse.h
new file mode 100644
index 000000000..271b3f55a
--- /dev/null
+++ b/src/mouse.h
@@ -0,0 +1,66 @@
+/*
+    C-Dogs SDL
+    A port of the legendary (and fun) action/arcade cdogs.
+
+    Copyright (c) 2013, Cong Xu
+    All rights reserved.
+
+    Redistribution and use in source and binary forms, with or without
+    modification, are permitted provided that the following conditions are met:
+
+    Redistributions of source code must retain the above copyright notice, this
+    list of conditions and the following disclaimer.
+    Redistributions in binary form must reproduce the above copyright notice,
+    this list of conditions and the following disclaimer in the documentation
+    and/or other materials provided with the distribution.
+
+    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+    ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+    POSSIBILITY OF SUCH DAMAGE.
+*/
+#ifndef __MOUSE
+#define __MOUSE
+
+#include <SDL_stdinc.h>
+
+#include <cdogs/pic_file.h>
+#include <cdogs/vector.h>
+
+typedef struct
+{
+	int left, top, right, bottom;
+	int tag;
+} MouseRect;
+
+typedef struct
+{
+	Uint32 previousButtons;
+	Uint32 currentButtons;
+	Vec2i previousPos;
+	Vec2i currentPos;
+	Pic *cursor;
+	// C-Dogs editor uses rectangles to detect mouse presses on key areas
+	// TODO: redesign this, is there a light-weight mouse-GUI framework?
+	MouseRect *rects;
+	MouseRect *rects2;
+} Mouse;
+
+extern Mouse gMouse;
+
+void MouseInit(Mouse *mouse, Pic *cursor);
+void MousePoll(Mouse *mouse);
+int MouseHasMoved(Mouse *mouse);
+void MouseSetRects(Mouse *mouse, MouseRect *rects, MouseRect *rects2);
+void MouseSetSecondaryRects(Mouse *mouse, MouseRect *rects);
+int MouseTryGetRectTag(Mouse *mouse, int *tag);
+void MouseDraw(Mouse *mouse);
+
+#endif
